## fenics-basix 0.5.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(BasixFull VERSION "0.5.1" LANGUAGES CXX)
add_subdirectory(cpp)
add_subdirectory(python)

=== cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

# Set the version
project(Basix VERSION "0.5.1" LANGUAGES CXX)
include(GNUInstallDirs)

if(SKBUILD)
  # Always use lib/ in the Python root. Otherwise, environment used for
  # wheels might place in lib64/, which CMake on some systems will not
  # find.
  set(CMAKE_INSTALL_LIBDIR lib)
endif()

include(FeatureSummary)

# Set the C++ standard
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Options
option(BUILD_SHARED_LIBS "Build Basix with shared libraries." ON)
add_feature_info(BUILD_SHARED_LIBS BUILD_SHARED_LIBS "Build Basix with shared libraries.")

find_package(BLAS REQUIRED)
find_package(LAPACK REQUIRED)

feature_summary(WHAT ALL)

# Source files
add_library(basix)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/basix/version.h.in basix/version.h)
include_directories(${CMAKE_CURRENT_BINARY_DIR})

set(HEADERS_basix
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/cell.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/dof-transformations.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/element-families.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/finite-element.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/indexing.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/interpolation.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/lattice.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/maps.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/math.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/moments.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/polynomials.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/polyset.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/precompute.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/quadrature.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-lagrange.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-nce-rtc.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-brezzi-douglas-marini.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-nedelec.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-raviart-thomas.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-regge.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-hhj.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-crouzeix-raviart.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-bubble.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-serendipity.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-hermite.h
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/mdspan.hpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/docs.h
  ${CMAKE_CURRENT_BINARY_DIR}/basix/version.h)

target_sources(basix PRIVATE
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/cell.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/dof-transformations.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/finite-element.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/interpolation.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/lattice.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/math.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/moments.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/polynomials.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/polyset.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/precompute.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/quadrature.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-lagrange.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-nce-rtc.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-brezzi-douglas-marini.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-nedelec.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-raviart-thomas.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-regge.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-hhj.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-crouzeix-raviart.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-bubble.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-hermite.cpp
  ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-serendipity.cpp)

# Configure the library
set_target_properties(basix PROPERTIES PUBLIC_HEADER basix/finite-element.h)
set_target_properties(basix PROPERTIES PRIVATE_HEADER "${HEADERS_basix}")
target_include_directories(basix PUBLIC
  $<INSTALL_INTERFACE:include>
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR};${CMAKE_CURRENT_SOURCE_DIR}>")

# The commented lines need CMake >= 3.18
# target_link_libraries(basix PRIVATE BLAS::BLAS)
# target_link_libraries(basix PRIVATE LAPACK::LAPACK)
target_link_libraries(basix PRIVATE ${BLAS_LIBRARIES})
target_link_libraries(basix PRIVATE ${LAPACK_LIBRARIES})

# Set compiler flags
list(APPEND BASIX_DEVELOPER_FLAGS -O2;-g;-pipe)
list(APPEND basix_compiler_flags -Wall;-Werror;-Wextra;-Wno-comment;-pedantic;)
target_compile_options(basix PRIVATE "$<$<OR:$<CONFIG:Debug>,$<CONFIG:Developer>>:${basix_compiler_flags}>")
target_compile_options(basix PRIVATE $<$<CONFIG:Developer>:${BASIX_DEVELOPER_FLAGS}>)

# Install the Basix library
install(TARGETS basix
  EXPORT BasixTargets
  PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  PRIVATE_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/basix
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT RuntimeExecutables
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT RuntimeLibraries
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} COMPONENT Development)

# Configure CMake helpers
include(CMakePackageConfigHelpers)
write_basic_package_version_file(BasixConfigVersion.cmake VERSION ${PACKAGE_VERSION}
  COMPATIBILITY AnyNewerVersion)
configure_package_config_file(BasixConfig.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/BasixConfig.cmake
  INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/basix)

# Install CMake files
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/BasixConfig.cmake ${CMAKE_CURRENT_BINARY_DIR}/BasixConfigVersion.cmake
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/basix COMPONENT Development)
install(EXPORT BasixTargets FILE BasixTargets.cmake NAMESPACE Basix::
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/basix)

=== python/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

PROJECT(basix_pybind11 VERSION "0.5.1"  LANGUAGES CXX)

# Set C++ standard
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# See https://gitlab.kitware.com/cmake/cmake/-/issues/16414
if (TARGET basix)
  add_library(Basix::basix ALIAS basix)
else()
  # Find Basix (C++)
  find_package(Basix REQUIRED)
endif()

# Correct COMPONENT specification Development.Module added only in CMake 3.18
# and above.
if(NOT SKBUILD)
  if(${CMAKE_VERSION} VERSION_GREATER_EQUAL "3.18.0")
    find_package(Python3 COMPONENTS Interpreter Development.Module REQUIRED)
  else()
    find_package(Python3 COMPONENTS Interpreter Development REQUIRED)
  endif()
endif()

execute_process(
  COMMAND
    "${Python3_EXECUTABLE}" -c
    "import pybind11; print(pybind11.get_cmake_dir())"
  OUTPUT_VARIABLE _tmp_dir
  OUTPUT_STRIP_TRAILING_WHITESPACE COMMAND_ECHO STDOUT)
list(APPEND CMAKE_PREFIX_PATH "${_tmp_dir}")

find_package(pybind11 REQUIRED CONFIG HINTS ${PYBIND11_DIR} ${PYBIND11_ROOT}
  $ENV{PYBIND11_DIR} $ENV{PYBIND11_ROOT})

# Create the binding library
pybind11_add_module(_basixcpp MODULE wrapper.cpp)
target_link_libraries(_basixcpp PRIVATE Basix::basix)

# Add strict compiler flags
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-Wall -Werror -Wextra -Wno-comment -pedantic" HAVE_PEDANTIC)
if (HAVE_PEDANTIC)
  target_compile_options(_basixcpp PRIVATE -Wall;-Wextra;-Werror;-Wno-comment;-pedantic)
endif()

# In Debug mode override pybind11 symbols visibility. Symbols must be
# visible to backtrace_symbols() to produce nice logs
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  target_compile_options(_basixcpp PRIVATE "-fvisibility=default")
endif()

# scikit-build specific steps
if (SKBUILD)
  # Add relative rpath so _basixcpp can find the Basix::basix library
  # when the build is relocated
  if (APPLE)
    set_target_properties(_basixcpp PROPERTIES INSTALL_RPATH "@loader_path/lib")
  else()
    set_target_properties(_basixcpp PROPERTIES INSTALL_RPATH "$ORIGIN/lib")
  endif()

  install(TARGETS _basixcpp DESTINATION .)
endif()

=== test/test_cmake/CMakeLists.txt ===
# Example of CMakeLists.txt for downstream C++ project (eg DOLFINx)
# Used to check correctly installed package during tests and wheel creation.
cmake_minimum_required(VERSION 3.16)

project(basix_test)

# Set the C++ standard
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Use Python for detecting Basix
find_package(Python3 COMPONENTS Interpreter REQUIRED)

# From DOLFINx
execute_process(
  COMMAND ${Python3_EXECUTABLE} -c "import basix, os, sys; sys.stdout.write(os.path.dirname(basix.__file__))"
  OUTPUT_VARIABLE BASIX_PY_DIR
  RESULT_VARIABLE BASIX_PY_COMMAND_RESULT
  ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
if (BASIX_PY_DIR)
  message(STATUS "Adding ${BASIX_PY_DIR} to Basix search hints")
endif()
find_package(Basix REQUIRED CONFIG HINTS ${BASIX_PY_DIR})

add_executable(a.out main.cpp)
if (BASIX_PY_DIR AND IS_DIRECTORY ${BASIX_PY_DIR}/../fenics_basix.libs)
    set_target_properties(a.out PROPERTIES BUILD_RPATH ${BASIX_PY_DIR}/../fenics_basix.libs)
    set_target_properties(a.out PROPERTIES INSTALL_RPATH ${BASIX_PY_DIR}/../fenics_basix.libs)
endif()
target_link_libraries(a.out PRIVATE Basix::basix)

=== demo/cpp/demo_create_and_tabulate/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(demo_create_and_tabulate LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

find_package(Basix REQUIRED)

add_executable(${PROJECT_NAME} main.cpp)
target_link_libraries(${PROJECT_NAME} Basix::basix)

=== demo/cpp/demo_dof_transformations/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(demo_dof_transformations LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

find_package(Basix REQUIRED)

add_executable(${PROJECT_NAME} main.cpp)
target_link_libraries(${PROJECT_NAME} Basix::basix)

=== debian/changelog ===
fenics-basix (0.5.1-1) unstable; urgency=medium

  * New upstream release.
    - versioned Build-Depends: python3-numpy (>= 1.21~)
    - provides pregenerated cpp/basix/docs.h

 -- Drew Parsons <dparsons@debian.org>  Tue, 20 Sep 2022 10:32:56 +0200

fenics-basix (0.5.0-1exp1) experimental; urgency=medium

  * New upstream release.
    - requires C++20, no longer uses xtensor, xtl.
      Drop Build-Depends: libxtensor-dev, libxsimd-dev, xtl-dev.
    - ABI bump to libbasix0.5
  * use pyproject to build python module
    - Build-Depends: pybuild-plugin-pyproject, python3-skbuild
  * bump versioned Build-Depends: python3-pybind11 (>= 2.6.4~)
  * clean more build files with dh_clean override

 -- Drew Parsons <dparsons@debian.org>  Wed, 17 Aug 2022 14:35:26 +0200

=== debian/control ===
Source: fenics-basix
Section: python
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Drew Parsons <dparsons@debian.org>
Build-Depends: debhelper-compat (= 13),
 dh-python,
 python3-setuptools,
 python3-all-dev:any,
 python3-ufl,
 python3-numpy (>= 1.21~),
 python3-pybind11 (>= 2.6.4~),
 pybuild-plugin-pyproject,
 python3-pytest,
 python3-skbuild,
 python3-sphinx,
 python3-sympy,
 python3-wheel,
 cmake (>= 3.16),
 chrpath,
 cython3,
 libeigen3-dev,
 libjs-mathjax,
 ninja-build,
 libblas-dev | libopenblas-dev | libblis-dev | libatlas-base-dev | libblas.so,
 liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so
Build-Depends-Indep: doxygen, graphviz
Standards-Version: 4.6.1
Homepage: https://github.com/FEniCS/basix
Vcs-Browser: https://salsa.debian.org/science-team/fenics/fenics-basix
Vcs-Git: https://salsa.debian.org/science-team/fenics/fenics-basix.git
Testsuite: autopkgtest-pkg-python
Rules-Requires-Root: no

Package: libbasix-dev
Architecture: any
Multi-Arch: same
Depends: libbasix0.5 (= ${binary:Version}),
 libeigen3-dev,
 ${misc:Depends}, ${shlibs:Depends}
Suggests: python3-basix, basix-doc
Description: Finite Element Basis Function Definition Runtime Library (development headers)
 Computes FE basis functions and derivatives for the following
 elements:
  -   Lagrange (interval, triangle, tetrahedron, prism, pyramid,
  quadrilateral, hexahedron)
  -   Nédélec (triangle, tetrahedron)
  -   Nédélec Second Kind (triangle, tetrahedron)
  -   Raviart-Thomas (triangle, tetrahedron)
  -   Regge (triangle, tetrahedron)
  -   Crouzeix-Raviart (triangle, tetrahedron)
 .
 Computes quadrature rules on different cell types
 .
 Provides reference topology and geometry for reference cells of each
 type.
 .
 Python wrapper provided with pybind11.
 .
 This package installs the development files for the shared library.

Package: libbasix0.5
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Suggests: basix-doc
Description: Finite Element Basis Function Definition Runtime Library (Python 3)
 Computes FE basis functions and derivatives for the following
 elements:
  -   Lagrange (interval, triangle, tetrahedron, prism, pyramid,
  quadrilateral, hexahedron)
  -   Nédélec (triangle, tetrahedron)
  -   Nédélec Second Kind (triangle, tetrahedron)
  -   Raviart-Thomas (triangle, tetrahedron)
  -   Regge (triangle, tetrahedron)
  -   Crouzeix-Raviart (triangle, tetrahedron)
 .
 Computes quadrature rules on different cell types
 .
 Provides reference topology and geometry for reference cells of each
 type.
 .
 Python wrapper provided with pybind11.
 .
 This package installs the shared library.

Package: python3-basix
Architecture: any
Depends: libbasix-dev  (= ${binary:Version}),
 ${python3:Depends}, ${misc:Depends}, ${shlibs:Depends}
Recommends: python3-numba
Breaks: python3-ffcx (<< 1:0.4~)
Suggests: basix-doc
Description: Finite Element Basis Function Definition Runtime Library (Python 3)
 Computes FE basis functions and derivatives for the following
 elements:
  -   Lagrange (interval, triangle, tetrahedron, prism, pyramid,
  quadrilateral, hexahedron)
  -   Nédélec (triangle, tetrahedron)
  -   Nédélec Second Kind (triangle, tetrahedron)
  -   Raviart-Thomas (triangle, tetrahedron)
  -   Regge (triangle, tetrahedron)
  -   Crouzeix-Raviart (triangle, tetrahedron)
 .
 Computes quadrature rules on different cell types
 .
 Provides reference topology and geometry for reference cells of each
 type.
 .
 Python wrapper provided with pybind11.
 .
 This package installs the library for Python 3.

Package: basix-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: libjs-mathjax, ${sphinxdoc:Depends}, ${misc:Depends}
Suggests: python3-basix
Description: Finite Element Basis Function Definition Runtime Library (docs)
 Computes FE basis functions and derivatives for the following
 elements:
  -   Lagrange (interval, triangle, tetrahedron, prism, pyramid,
  quadrilateral, hexahedron)
  -   Nédélec (triangle, tetrahedron)
  -   Nédélec Second Kind (triangle, tetrahedron)
  -   Raviart-Thomas (triangle, tetrahedron)
  -   Regge (triangle, tetrahedron)
  -   Crouzeix-Raviart (triangle, tetrahedron)
 .
 Computes quadrature rules on different cell types
 .
 Provides reference topology and geometry for reference cells of each
 type.
 .
 This is the common documentation package.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

include /usr/share/dpkg/default.mk
export DEB_HOST_MULTIARCH

DEB_SOURCE_PACKAGE := $(strip $(shell egrep '^Source: ' debian/control | cut -f 2 -d ':'))
DEB_VERSION := $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')
DEB_NOEPOCH_VERSION := $(shell echo $(DEB_VERSION) | cut -d: -f2-)
DEB_UPSTREAM_VERSION := $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')
DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -e 's/\+dfsg.*$$//p')

VERSION := $(DEB_STRIPPED_UPSTREAM_VERSION)
MAJOR_VERSION := $(shell echo $(DEB_STRIPPED_UPSTREAM_VERSION) | sed "s/^\([^.]*\)\..*$$/\1/")
SOVERSION := $(MAJOR_VERSION)

PY3VERS := $(shell py3versions -v --requested debian/control | tac -s' ')
PY3VER_DEFAULT := $(shell py3versions -dv)

empty :=
space := $(empty)$(empty)

#ifneq (,$(findstring $(DEB_HOST_ARCH),mipsel))
  PYTEST_OPTIONS = -k "not numba"
#endif


%:
	dh $@ --with python3,sphinxdoc --buildsystem=cmake


override_dh_auto_clean:
	rm -rf cpp/basix/version.h
	rm -rf doc/cpp/html doc/cpp/latex
	rm -rf .pybuild
	rm -rf python/build python/setup.cfg
	rm -rf python/fenics_basix.egg-info
	rm -rf doc/python/build doc/python/source/_autosummary
	rm -rf ./.pytest_cache test/.pytest_cache  test/__pycache__  python/testing_build
	dh_auto_clean

override_dh_auto_configure:
	dh_auto_configure --sourcedir=cpp

override_dh_auto_build-indep: export http_proxy=127.0.0.1:9
override_dh_auto_build-indep: export https_proxy=127.0.0.1:9
override_dh_auto_build-indep:
	dh_auto_build --sourcedir=cpp -i
	cd doc/cpp; doxygen

execute_after_dh_auto_install:
	LD_LIBRARY_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) \
	  CMAKE_PREFIX_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/cmake \
	  pybuild --dir=$(CURDIR)/python --system=pyproject --name=basix

execute_before_dh_install-indep:
	LD_LIBRARY_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) PYTHONPATH=$(CURDIR)/debian/python3-basix/usr/lib/python$(PY3VER_DEFAULT)/dist-packages:${PYTHONPATH} $(MAKE) -C doc/python html
	sed 's|href="https://fenicsproject.org/docs/basix/main/cpp/"|href="file:/usr/share/doc/basix-doc/cpp/index.html"|' -i doc/python/build/html/index.html

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
execute_before_dh_python3:
	cd test; LD_LIBRARY_PATH=$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) PYTHONPATH=$(CURDIR)/debian/python3-basix/usr/lib/python$(PY3VER_DEFAULT)/dist-packages:${PYTHONPATH} pytest-3 $(PYTEST_OPTIONS)
endif

=== debian/tests/control ===
Test-Command: pytest-3 -k "not numba"
Depends: python3-basix,
 python3-pytest,
 python3-ufl,
 python3-numpy,
 python3-sympy

## fenics-basix 0.6.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)

project(BasixFull VERSION "0.6.0" LANGUAGES CXX)
add_subdirectory(cpp)
add_subdirectory(python)

=== cpp/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.16)
 
 # Set the version
-project(Basix VERSION "0.5.1" LANGUAGES CXX)
+project(Basix VERSION "0.6.0" LANGUAGES CXX)
 include(GNUInstallDirs)
 
 if(SKBUILD)
@@ -48,6 +48,7 @@
   ${CMAKE_CURRENT_SOURCE_DIR}/basix/polyset.h
   ${CMAKE_CURRENT_SOURCE_DIR}/basix/precompute.h
   ${CMAKE_CURRENT_SOURCE_DIR}/basix/quadrature.h
+  ${CMAKE_CURRENT_SOURCE_DIR}/basix/sobolev-spaces.h
   ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-lagrange.h
   ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-nce-rtc.h
   ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-brezzi-douglas-marini.h
@@ -75,6 +76,7 @@
   ${CMAKE_CURRENT_SOURCE_DIR}/basix/polyset.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/basix/precompute.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/basix/quadrature.cpp
+  ${CMAKE_CURRENT_SOURCE_DIR}/basix/sobolev-spaces.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-lagrange.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-nce-rtc.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-brezzi-douglas-marini.cpp

=== python/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.16)
 
-PROJECT(basix_pybind11 VERSION "0.5.1"  LANGUAGES CXX)
+PROJECT(basix_pybind11 VERSION "0.6.0"  LANGUAGES CXX)
 
 # Set C++ standard
 set(CMAKE_CXX_STANDARD 20)

=== debian/changelog ===
fenics-basix (0.6.0-6) unstable; urgency=medium

  * source-only upload for migration to testing. Closes: #1043062.

 -- Drew Parsons <dparsons@debian.org>  Wed, 09 Aug 2023 10:15:34 +0200

fenics-basix (0.6.0-5) unstable; urgency=medium

  * gcc-13 patches evidently altered the ABI.
    Shift soname to 0.6gcc13 with project version 0.6.0.13

 -- Drew Parsons <dparsons@debian.org>  Mon, 24 Jul 2023 13:32:04 +0200

fenics-basix (0.6.0-4) unstable; urgency=medium

  * debian patch gcc13_fix.patch enables build with gcc-13.
    Closes: #1037650.

 -- Drew Parsons <dparsons@debian.org>  Fri, 21 Jul 2023 00:13:52 +0200

fenics-basix (0.6.0-3) unstable; urgency=medium

  * python3-basix Depends: python3-ufl (>= 2023.1.0~)
    (for ufl.sobolevspace.HInf used in ufl_wrapper.py)

 -- Drew Parsons <dparsons@debian.org>  Tue, 27 Jun 2023 01:57:17 +0200

fenics-basix (0.6.0-2) unstable; urgency=medium

  * Standards-Version: 4.6.2

 -- Drew Parsons <dparsons@debian.org>  Sat, 24 Jun 2023 15:23:44 +0200

fenics-basix (0.6.0-1exp1) experimental; urgency=medium

  * New upstream release
    - ABI bump to 0.6
    - versioned Build-Depends: python3-ufl (>= 2023.1.0~)

 -- Drew Parsons <dparsons@debian.org>  Sun, 15 Jan 2023 01:58:27 +0100

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
  dh-python,
  python3-setuptools,
  python3-all-dev:any,
- python3-ufl,
+ python3-ufl (>= 2023.1.0~),
  python3-numpy (>= 1.21~),
  python3-pybind11 (>= 2.6.4~),
  pybuild-plugin-pyproject,
@@ -25,7 +25,7 @@
  libblas-dev | libopenblas-dev | libblis-dev | libatlas-base-dev | libblas.so,
  liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so
 Build-Depends-Indep: doxygen, graphviz
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Homepage: https://github.com/FEniCS/basix
 Vcs-Browser: https://salsa.debian.org/science-team/fenics/fenics-basix
 Vcs-Git: https://salsa.debian.org/science-team/fenics/fenics-basix.git
@@ -35,7 +35,7 @@
 Package: libbasix-dev
 Architecture: any
 Multi-Arch: same
-Depends: libbasix0.5 (= ${binary:Version}),
+Depends: libbasix0.6gcc13 (= ${binary:Version}),
  libeigen3-dev,
  ${misc:Depends}, ${shlibs:Depends}
 Suggests: python3-basix, basix-doc
@@ -59,7 +59,7 @@
  .
  This package installs the development files for the shared library.
 
-Package: libbasix0.5
+Package: libbasix0.6gcc13
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
@@ -87,6 +87,7 @@
 Package: python3-basix
 Architecture: any
 Depends: libbasix-dev  (= ${binary:Version}),
+ python3-ufl (>= 2023.1.0~),
  ${python3:Depends}, ${misc:Depends}, ${shlibs:Depends}
 Recommends: python3-numba
 Breaks: python3-ffcx (<< 1:0.4~)

## fenics-basix 0.7.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)

project(BasixFull VERSION "0.7.0" LANGUAGES CXX)
add_subdirectory(cpp)
add_subdirectory(python)

=== cpp/CMakeLists.txt ===
--- 
+++ 
@@ -1,14 +1,15 @@
-cmake_minimum_required(VERSION 3.16)
+cmake_minimum_required(VERSION 3.19)
 
 # Set the version
-project(Basix VERSION "0.6.0" LANGUAGES CXX)
+project(Basix VERSION "0.7.0" LANGUAGES CXX)
 include(GNUInstallDirs)
 
 if(SKBUILD)
   # Always use lib/ in the Python root. Otherwise, environment used for
   # wheels might place in lib64/, which CMake on some systems will not
   # find.
-  set(CMAKE_INSTALL_LIBDIR lib)
+  set(CMAKE_INSTALL_LIBDIR basix/lib)
+  set(CMAKE_INSTALL_INCLUDEDIR basix/include)
 endif()
 
 include(FeatureSummary)
@@ -70,7 +71,6 @@
   ${CMAKE_CURRENT_SOURCE_DIR}/basix/finite-element.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/basix/interpolation.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/basix/lattice.cpp
-  ${CMAKE_CURRENT_SOURCE_DIR}/basix/math.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/basix/moments.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/basix/polynomials.cpp
   ${CMAKE_CURRENT_SOURCE_DIR}/basix/polyset.cpp
@@ -93,14 +93,11 @@
 set_target_properties(basix PROPERTIES PUBLIC_HEADER basix/finite-element.h)
 set_target_properties(basix PROPERTIES PRIVATE_HEADER "${HEADERS_basix}")
 target_include_directories(basix PUBLIC
-  $<INSTALL_INTERFACE:include>
+  $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
   "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR};${CMAKE_CURRENT_SOURCE_DIR}>")
 
-# The commented lines need CMake >= 3.18
-# target_link_libraries(basix PRIVATE BLAS::BLAS)
-# target_link_libraries(basix PRIVATE LAPACK::LAPACK)
-target_link_libraries(basix PRIVATE ${BLAS_LIBRARIES})
-target_link_libraries(basix PRIVATE ${LAPACK_LIBRARIES})
+target_link_libraries(basix PRIVATE BLAS::BLAS)
+target_link_libraries(basix PRIVATE LAPACK::LAPACK)
 
 # Set compiler flags
 list(APPEND BASIX_DEVELOPER_FLAGS -O2;-g;-pipe)

=== python/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.16)
 
-PROJECT(basix_pybind11 VERSION "0.6.0"  LANGUAGES CXX)
+PROJECT(basix_pybind11 VERSION "0.7.0"  LANGUAGES CXX)
 
 # Set C++ standard
 set(CMAKE_CXX_STANDARD 20)
@@ -63,5 +63,5 @@
     set_target_properties(_basixcpp PROPERTIES INSTALL_RPATH "$ORIGIN/lib")
   endif()
 
-  install(TARGETS _basixcpp DESTINATION .)
+  install(TARGETS _basixcpp DESTINATION basix)
 endif()

=== test/test_cmake/CMakeLists.txt ===
# Example of CMakeLists.txt for downstream C++ project (eg DOLFINx or a Basix demo)
# Used to check correctly installed package during tests and wheel creation.
cmake_minimum_required(VERSION 3.16)

project(basix_test)

# Set the C++ standard
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# Use Python for detecting Basix
find_package(Python3 COMPONENTS Interpreter)

if (${Python3_FOUND})
  execute_process(
    COMMAND ${Python3_EXECUTABLE} -c "import basix, os, sys; sys.stdout.write(os.path.dirname(basix.__file__))"
    OUTPUT_VARIABLE BASIX_PY_DIR
    RESULT_VARIABLE BASIX_PY_COMMAND_RESULT
    ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
  if (BASIX_PY_DIR)
    message(STATUS "Adding ${BASIX_PY_DIR} to Basix search hints")
  endif()
endif()
find_package(Basix REQUIRED CONFIG HINTS ${BASIX_PY_DIR})

add_executable(a.out main.cpp)
if (BASIX_PY_DIR AND IS_DIRECTORY ${BASIX_PY_DIR}/../fenics_basix.libs)
    set_target_properties(a.out PROPERTIES BUILD_RPATH ${BASIX_PY_DIR}/../fenics_basix.libs)
    set_target_properties(a.out PROPERTIES INSTALL_RPATH ${BASIX_PY_DIR}/../fenics_basix.libs)
endif()
target_link_libraries(a.out PRIVATE Basix::basix)

=== demo/cpp/demo_create_and_tabulate/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,23 @@
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
 
-find_package(Basix REQUIRED)
+# Use Python for detecting Basix when installed using combined build
+find_package(Python3 COMPONENTS Interpreter)
+if (${Python3_FOUND})
+  execute_process(
+    COMMAND ${Python3_EXECUTABLE} -c "import basix, os, sys; sys.stdout.write(os.path.dirname(basix.__file__))"
+    OUTPUT_VARIABLE BASIX_PY_DIR
+    RESULT_VARIABLE BASIX_PY_COMMAND_RESULT
+    ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
+  if (BASIX_PY_DIR)
+    message(STATUS "Adding ${BASIX_PY_DIR} to Basix search hints")
+  endif()
+endif()
+find_package(Basix REQUIRED CONFIG HINTS ${BASIX_PY_DIR})
 
 add_executable(${PROJECT_NAME} main.cpp)
+if (BASIX_PY_DIR AND IS_DIRECTORY ${BASIX_PY_DIR}/../fenics_basix.libs)
+    set_target_properties(${PROJECT_NAME} PROPERTIES BUILD_RPATH ${BASIX_PY_DIR}/../fenics_basix.libs)
+    set_target_properties(${PROJECT_NAME} PROPERTIES INSTALL_RPATH ${BASIX_PY_DIR}/../fenics_basix.libs)
+endif()
 target_link_libraries(${PROJECT_NAME} Basix::basix)

=== demo/cpp/demo_dof_transformations/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,23 @@
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
 
-find_package(Basix REQUIRED)
+# Use Python for detecting Basix when installed using combined build
+find_package(Python3 COMPONENTS Interpreter)
+if (${Python3_FOUND})
+  execute_process(
+    COMMAND ${Python3_EXECUTABLE} -c "import basix, os, sys; sys.stdout.write(os.path.dirname(basix.__file__))"
+    OUTPUT_VARIABLE BASIX_PY_DIR
+    RESULT_VARIABLE BASIX_PY_COMMAND_RESULT
+    ERROR_QUIET OUTPUT_STRIP_TRAILING_WHITESPACE)
+  if (BASIX_PY_DIR)
+    message(STATUS "Adding ${BASIX_PY_DIR} to Basix search hints")
+  endif()
+endif()
+find_package(Basix REQUIRED CONFIG HINTS ${BASIX_PY_DIR})
 
 add_executable(${PROJECT_NAME} main.cpp)
+if (BASIX_PY_DIR AND IS_DIRECTORY ${BASIX_PY_DIR}/../fenics_basix.libs)
+    set_target_properties(${PROJECT_NAME} PROPERTIES BUILD_RPATH ${BASIX_PY_DIR}/../fenics_basix.libs)
+    set_target_properties(${PROJECT_NAME} PROPERTIES INSTALL_RPATH ${BASIX_PY_DIR}/../fenics_basix.libs)
+endif()
 target_link_libraries(${PROJECT_NAME} Basix::basix)

=== debian/changelog ===
fenics-basix (0.7.0-2.1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 18:14:47 +0000

fenics-basix (0.7.0-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062553

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Wed, 28 Feb 2024 04:38:54 +0000

fenics-basix (0.7.0-2) unstable; urgency=medium

  * Depends: python3-ufl (>= 2023.2.0~)

 -- Drew Parsons <dparsons@debian.org>  Mon, 30 Oct 2023 22:48:08 +0100

fenics-basix (0.7.0-1exp1) experimental; urgency=medium

  * New upstream release. ABI bump to 0.7.
    - applies or deprecates debian patches gcc13_fix.patch
      skip_flaky_arch_numba_tests.patch, test_numba_conditional.patch

 -- Drew Parsons <dparsons@debian.org>  Wed, 04 Oct 2023 17:14:54 +0200

=== debian/control ===
--- 
+++ 
@@ -1,13 +1,14 @@
 Source: fenics-basix
 Section: python
 Priority: optional
-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Drew Parsons <dparsons@debian.org>
-Build-Depends: debhelper-compat (= 13),
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
  dh-python,
  python3-setuptools,
  python3-all-dev:any,
- python3-ufl (>= 2023.1.0~),
+ python3-ufl (>= 2023.2.0~),
  python3-numpy (>= 1.21~),
  python3-pybind11 (>= 2.6.4~),
  pybuild-plugin-pyproject,
@@ -35,7 +36,7 @@
 Package: libbasix-dev
 Architecture: any
 Multi-Arch: same
-Depends: libbasix0.6gcc13 (= ${binary:Version}),
+Depends: libbasix0.7t64 (= ${binary:Version}),
  libeigen3-dev,
  ${misc:Depends}, ${shlibs:Depends}
 Suggests: python3-basix, basix-doc
@@ -59,7 +60,10 @@
  .
  This package installs the development files for the shared library.
 
-Package: libbasix0.6gcc13
+Package: libbasix0.7t64
+Provides: ${t64:Provides}
+Replaces: libbasix0.7
+Breaks: libbasix0.7 (<< ${source:Version})
 Architecture: any
 Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
@@ -87,7 +91,7 @@
 Package: python3-basix
 Architecture: any
 Depends: libbasix-dev  (= ${binary:Version}),
- python3-ufl (>= 2023.1.0~),
+ python3-ufl (>= 2023.2.0~),
  ${python3:Depends}, ${misc:Depends}, ${shlibs:Depends}
 Recommends: python3-numba
 Breaks: python3-ffcx (<< 1:0.4~)

=== debian/rules ===
--- 
+++ 
@@ -5,16 +5,6 @@
 
 include /usr/share/dpkg/default.mk
 export DEB_HOST_MULTIARCH
-
-DEB_SOURCE_PACKAGE := $(strip $(shell egrep '^Source: ' debian/control | cut -f 2 -d ':'))
-DEB_VERSION := $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')
-DEB_NOEPOCH_VERSION := $(shell echo $(DEB_VERSION) | cut -d: -f2-)
-DEB_UPSTREAM_VERSION := $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')
-DEB_STRIPPED_UPSTREAM_VERSION = $(shell echo $(DEB_UPSTREAM_VERSION) | sed -e 's/\+dfsg.*$$//p')
-
-VERSION := $(DEB_STRIPPED_UPSTREAM_VERSION)
-MAJOR_VERSION := $(shell echo $(DEB_STRIPPED_UPSTREAM_VERSION) | sed "s/^\([^.]*\)\..*$$/\1/")
-SOVERSION := $(MAJOR_VERSION)
 
 PY3VERS := $(shell py3versions -v --requested debian/control | tac -s' ')
 PY3VER_DEFAULT := $(shell py3versions -dv)

## fenics-basix 0.8.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)

project(BasixFull VERSION "0.8.0" LANGUAGES CXX)
set(BASIX_FULL_SKBUILD TRUE)
add_subdirectory(cpp)
add_subdirectory(python)

=== cpp/CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.19)
 
 # Set the version
-project(Basix VERSION "0.7.0" LANGUAGES CXX)
+project(Basix VERSION "0.8.0" LANGUAGES CXX)
 include(GNUInstallDirs)
 
 if(SKBUILD)
@@ -62,7 +62,6 @@
   ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-serendipity.h
   ${CMAKE_CURRENT_SOURCE_DIR}/basix/e-hermite.h
   ${CMAKE_CURRENT_SOURCE_DIR}/basix/mdspan.hpp
-  ${CMAKE_CURRENT_SOURCE_DIR}/basix/docs.h
   ${CMAKE_CURRENT_BINARY_DIR}/basix/version.h)
 
 target_sources(basix PRIVATE

=== python/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.19)

# nanobind uses aligned deallocators only present on macOS > 10.14
if(APPLE)
  set(CMAKE_OSX_DEPLOYMENT_TARGET "10.14")
endif()

project(basix_nanobind VERSION "0.8.0" LANGUAGES CXX)

# Set C++ standard
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# See https://gitlab.kitware.com/cmake/cmake/-/issues/16414
if(TARGET basix)
  add_library(Basix::basix ALIAS basix)
else()
  find_package(Basix REQUIRED)
endif()

find_package(Python COMPONENTS Interpreter Development.Module REQUIRED)

# Detect the installed nanobind package and import it into CMake
execute_process(
  COMMAND "${Python_EXECUTABLE}" -c "import nanobind; print(nanobind.cmake_dir())"
  OUTPUT_STRIP_TRAILING_WHITESPACE OUTPUT_VARIABLE NB_DIR)
list(APPEND CMAKE_PREFIX_PATH "${NB_DIR}")
find_package(nanobind CONFIG REQUIRED)

# Create the binding library
nanobind_add_module(_basixcpp wrapper.cpp)
target_link_libraries(_basixcpp PRIVATE Basix::basix)

# Add strict compiler flags
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG("-Wall -Werror -Wextra -Wno-comment -pedantic" HAVE_PEDANTIC)

if(HAVE_PEDANTIC)
  target_compile_options(_basixcpp PRIVATE -Wall;-Wextra;-Werror;-Wno-comment)

  # target_compile_options(_basixcpp PRIVATE -Wall;-Wextra;-Werror;-Wno-comment;-pedantic)
endif()

# Add relative rpath so _basixcpp can find the Basix::basix library
# when the build is relocated
if(BASIX_FULL_SKBUILD)
  if(APPLE)
    set_target_properties(_basixcpp PROPERTIES INSTALL_RPATH "@loader_path/lib")
  else()
    set_target_properties(_basixcpp PROPERTIES INSTALL_RPATH "$ORIGIN/lib")
  endif()
else()
  get_target_property(_location Basix::basix LOCATION)
  get_filename_component(_basix_dir ${_location} DIRECTORY)
  set_target_properties(_basixcpp PROPERTIES INSTALL_RPATH ${_basix_dir})
endif()

install(TARGETS _basixcpp LIBRARY DESTINATION basix)

=== debian/changelog ===
fenics-basix (0.8.0-9) unstable; urgency=medium

  * rebuild against lastest nanobind. See Bug#1085019.

 -- Drew Parsons <dparsons@debian.org>  Sun, 13 Oct 2024 10:48:59 +0200

fenics-basix (0.8.0-8) unstable; urgency=medium

  * New release to force rebuild of python3-basix with GCC 14.
    The issue is that the nanobind wrappers shipped in the current python3-basix
    version 0.8.0-7 were built with GCC 13, and thus are incompatible with
    GCC 14 nanobind wrappers in python3-dolfinx (see Bug #1074951), as well as
    GCC 14 nanobind wrappers in python3-dolfinx-mpc (see Bug #1074920).

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Wed, 28 Aug 2024 09:34:21 +0000

fenics-basix (0.8.0-7) unstable; urgency=medium

  * python3-basix also breaks python3-dolfinx-real and python3-dolfinx-complex
  * Fix lower bound on fenics-ufl in python3-basix: it must be 2024.1.0~, and
    not 2023.2.0~.

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sat, 08 Jun 2024 12:42:21 +0000

fenics-basix (0.8.0-6) unstable; urgency=medium

  * Add Breaks python3-dolfinx on python3-basix.
    Indeed, python3-basix since 0.8.0-3 is breaking dolfinx before 1:0.8.0-8
    because both basix and dolfinx python wrappers need to be compiled with
    nanobind 2.0

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Wed, 05 Jun 2024 08:56:36 +0000

fenics-basix (0.8.0-5) unstable; urgency=medium

  * Silence dpkg-architecture warning on stderr
      cannot determine CC system type, falling back to default (native
      compilation)
    on debci by adding gcc as a autokpgtest dependency

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Tue, 04 Jun 2024 13:32:17 +0000

fenics-basix (0.8.0-4) unstable; urgency=medium

  * Skip slowest tests on riscv64

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sun, 02 Jun 2024 13:57:25 +0000

fenics-basix (0.8.0-3) unstable; urgency=medium

  * Build-Depends on nanobind >= 2.0.0~

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sat, 01 Jun 2024 15:38:37 +0000

fenics-basix (0.8.0-2exp2) experimental; urgency=medium

  * Add debian/patches/PR825.diff for compatibility with nanobind 2.0

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sat, 01 Jun 2024 07:50:03 +0000

fenics-basix (0.8.0-2exp1) experimental; urgency=medium

  * Standards-Version: 4.7.0 (routine-update)
  * Fix Maintainer name of Debian Science team (routine-update)
  * Build-Depends: s/dh-python/dh-sequence-python3/ (routine-update)
  * True goal of this upload is to trigger a rebuild with nanobind 2.0.

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Sat, 01 Jun 2024 07:25:45 +0000

fenics-basix (0.8.0-1) unstable; urgency=medium

  * New upstream release for FEniCSx 0.8
  * Add Francesco Ballarin to uploaders
  * Build-Depends on python3-ufl 2024.1.0
  * Refresh version number in README.Debian
  * Refresh fix_doc_build.patch
  * Explicitly disable tests when running pybuild, since they are manually run in
    execute_before_dh_python3
  * Update fix_doc_build.patch: add numba to autodoc_mock_imports, otherwise sphinx
    would fail on systems which do not support numba.

 -- Francesco Ballarin <francesco.ballarin@unicatt.it>  Thu, 25 Apr 2024 08:53:44 +0000

fenics-basix (0.8.0~git20240321.0315c73-1) experimental; urgency=medium

  * New upstream snapshot of v0.8.0 preview
    - new ABI 0.8
    - Build-Depends: python3-nanobind, python3-scikit-build-core
      instead of python3-pybind11, python3-skbuild
    - Build-Depends: python3-ufl (>= 2023.2.0+git20240402.d25a40d)
    - python docs built directly with python3 -m sphinx not makefile
  * debian/tests: test all supported python versions
  * copy LICENSE to python dir during python module build. Upstream's
    pyproject.toml uses a relative path ../LICENSE, but pybuild copies
    source and builds in tmp, missing the LICENSE file unless it is
    copied there. Use debian/patches/python_local_LICENSE.patch.

 -- Drew Parsons <dparsons@debian.org>  Sun, 07 Apr 2024 14:01:14 +0200

=== debian/control ===
--- 
+++ 
@@ -1,45 +1,49 @@
 Source: fenics-basix
+Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Drew Parsons <dparsons@debian.org>,
+           Francesco Ballarin <francesco.ballarin@unicatt.it>
 Section: python
+Testsuite: autopkgtest-pkg-python
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Drew Parsons <dparsons@debian.org>
-Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
- dh-python,
- python3-setuptools,
- python3-all-dev:any,
- python3-ufl (>= 2023.2.0~),
- python3-numpy (>= 1.21~),
- python3-pybind11 (>= 2.6.4~),
- pybuild-plugin-pyproject,
- python3-pytest,
- python3-skbuild,
- python3-sphinx,
- python3-sympy,
- python3-wheel,
- cmake (>= 3.16),
- chrpath,
- cython3,
- libeigen3-dev,
- libjs-mathjax,
- ninja-build,
- libblas-dev | libopenblas-dev | libblis-dev | libatlas-base-dev | libblas.so,
- liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so
-Build-Depends-Indep: doxygen, graphviz
-Standards-Version: 4.6.2
-Homepage: https://github.com/FEniCS/basix
+Build-Depends: dpkg-dev (>= 1.22.5),
+               debhelper-compat (= 13),
+               dh-sequence-python3,
+               python3-setuptools,
+               python3-all-dev:any,
+               python3-ufl (>= 2024.1.0~),
+               python3-nanobind (>= 2.0.0~),
+               python3-numpy,
+               pybuild-plugin-pyproject,
+               python3-pytest,
+               python3-scikit-build-core,
+               python3-sphinx,
+               python3-sympy,
+               python3-wheel,
+               cmake,
+               chrpath,
+               cython3,
+               libeigen3-dev,
+               libjs-mathjax,
+               ninja-build,
+               libblas-dev | libopenblas-dev | libblis-dev | libatlas-base-dev | libblas.so,
+               liblapack-dev | libopenblas-dev | libatlas-base-dev | liblapack.so
+Build-Depends-Indep: doxygen,
+                     graphviz
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/science-team/fenics/fenics-basix
 Vcs-Git: https://salsa.debian.org/science-team/fenics/fenics-basix.git
-Testsuite: autopkgtest-pkg-python
+Homepage: https://github.com/FEniCS/basix
 Rules-Requires-Root: no
 
 Package: libbasix-dev
 Architecture: any
 Multi-Arch: same
-Depends: libbasix0.7t64 (= ${binary:Version}),
- libeigen3-dev,
- ${misc:Depends}, ${shlibs:Depends}
-Suggests: python3-basix, basix-doc
+Depends: libbasix0.8 (= ${binary:Version}),
+         libeigen3-dev,
+         ${misc:Depends},
+         ${shlibs:Depends}
+Suggests: python3-basix,
+          basix-doc
 Description: Finite Element Basis Function Definition Runtime Library (development headers)
  Computes FE basis functions and derivatives for the following
  elements:
@@ -60,14 +64,13 @@
  .
  This package installs the development files for the shared library.
 
-Package: libbasix0.7t64
-Provides: ${t64:Provides}
-Replaces: libbasix0.7
-Breaks: libbasix0.7 (<< ${source:Version})
+Package: libbasix0.8
 Architecture: any
 Multi-Arch: same
-Depends: ${misc:Depends}, ${shlibs:Depends}
+Depends: ${misc:Depends},
+         ${shlibs:Depends}
 Suggests: basix-doc
+Provides: ${t64:Provides}
 Description: Finite Element Basis Function Definition Runtime Library (Python 3)
  Computes FE basis functions and derivatives for the following
  elements:
@@ -91,11 +94,16 @@
 Package: python3-basix
 Architecture: any
 Depends: libbasix-dev  (= ${binary:Version}),
- python3-ufl (>= 2023.2.0~),
- ${python3:Depends}, ${misc:Depends}, ${shlibs:Depends}
+         python3-ufl (>= 2024.1.0~),
+         ${python3:Depends},
+         ${misc:Depends},
+         ${shlibs:Depends}
 Recommends: python3-numba
-Breaks: python3-ffcx (<< 1:0.4~)
 Suggests: basix-doc
+Breaks: python3-ffcx (<< 1:0.4~),
+        python3-dolfinx (<< 1:0.8.0-11),
+        python3-dolfinx-real (<< 1:0.8.0-11),
+        python3-dolfinx-complex (<< 1:0.8.0-11)
 Description: Finite Element Basis Function Definition Runtime Library (Python 3)
  Computes FE basis functions and derivatives for the following
  elements:
@@ -120,7 +128,9 @@
 Architecture: all
 Multi-Arch: foreign
 Section: doc
-Depends: libjs-mathjax, ${sphinxdoc:Depends}, ${misc:Depends}
+Depends: libjs-mathjax,
+         ${sphinxdoc:Depends},
+         ${misc:Depends}
 Suggests: python3-basix
 Description: Finite Element Basis Function Definition Runtime Library (docs)
  Computes FE basis functions and derivatives for the following
